/* global.h
Converter xfig 3.2 to sim script

96/01/23 
*/

/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------------------------------------------*/

#define FIG_2_DEK_FLAG /* to prevent compiling ColSim things in malloc_call.c */

#define UNIT_MAX   200	 /* Max units + DEAD_MAX */
#define PAR_MAX    50	 /**/
#define INPUT_MAX  50	 /**/
#define OUT_MAX    70 	 /* max number of outputs */
#define FIELD_MAX 300500 /* max no of letters in 'sim.fig' */
#define LINE_MAX  35000  /* 26575 12000  max no of lines  in 'sim.fig'  (7000) */
#define WORD_MAX   40    /* max no of words in each line in 'sim.fig' */
#define LETTER_MAX 100 	 /* max no of letters in each word n 'sim.fig' */
#define DERIV_MAX  25	 /**/
#define CONNECTION_MAX 600   /* maximum number of connection lines */
#define END 99999

#define SUBSTITUTE_MAX 15000 /* max letters for substitute strings */

/* auto_router defines */
#define EDGE_MAX 30

#define X1 1
#define Y1 2
#define X2 3
#define Y2 4
 
#define XPOS 1
#define XNEG 2
#define YPOS 3
#define YNEG 4
 
#define I_LINE 5
#define I_LINE_OFFSET 6


/* static int point=0; / * global pointer for CharField_substitute */

struct substitute_struct {
 char *CharField;
 int  point;
};


/*----GLOBAL VARIABLES--------------------------------------------------------*/

/* FILE	*xfig_script,*sim_script;   file pointers */
                     		                /*files for read & write*/

char**    malloc_2char(int x,int y);
char***   malloc_3char(int x,int y,int z);
double*   malloc_1double(int x);
double**  malloc_2double(int x,int y);
double*** malloc_3double(int x,int y,int z);
int*      malloc_1int(int x);
int**     malloc_2int(int x,int y);
int***    malloc_3int(int x,int y,int z);

/*----FUNCTION----------TYPE----VARIABLE--------------- INFORMATION-----------*/

int read_dek(						/**/
			int 	*type,			/**/
			double 	**par,			/**/
			int 	**in_u,			/**/
			int 	**in_nr,		/**/
                	double 	**out_n,		/**/
                	double 	**deriv_o);		/**/

int  read_fig(char ***line_word_array,char *CharField, int field_max_dyn,
              int *unit_max,int *par_max,int *field_max,int *line_max,
              int *word_max,int *letter_max,int *deriv_max,int *input_max,
              int *letter_max_line);

int write_fig(
               char    ***line_word_array,
               int     no_of_lines,
               int     **compound_coordinates,
               int     **connection,
               int     **x_connection,
               int     **y_connection,
               int     AutoRouter_flag
             );

int auto_router(
                        char    ***line_word_array,     /**/
                        int     no_of_lines,            /**/
                        int     ***input_box,           /**/
                        int     ***output_box,          /**/
                        int     letter_max_line,
                        int     **compound_coordinates,
                        int     **connection,
                        int     **x_connection,
                        int     **y_connection );

/* WriteXfigConnection is used to write to .xfig and/or to line_str */
/* see auto_router.c */
int WriteXfigConnection(char *line_string, char ***line_word_array,
                        int **connection,int i_connection,
                        int **x_connection,int **y_connection,int DotXfig_flag);



int interpreter(					/**/
			int	*type,			/**/
			double	**par,			/**/
			int 	**in_u,			/**/
			int 	**in_nr,		/**/
               		double 	**out_n,		/**/
               		double 	**deriv_o,		/**/
             		char 	***line_word_array,	/**/
             		int 	no_of_lines,		/**/
                	int 	***input_box,		/**/
                	int 	***output_box,		/**/
               		double 	**par_xfig,		/**/
               		char 	***par_comment,		/**/
               		double 	**inp_init_xfig,	/**/
               		char 	***inp_unit_xfig,	/**/
                      	char 	***inp_comment,		/**/
               		double 	**deriv_xfig,		/**/
               		char 	***deriv_comment,	/**/
               		double 	**out_xfig,		/**/
               		char 	***out_unit_xfig,	/**/
                      	char 	***out_comment,		/**/
               		int 	*type_xfig,		/**/
               		int 	*unit_xfig,		/**/
               		char 	**info_line,		/**/
               		int 	**input_unit_xfig,	/**/
               		int 	**input_out_nr_xfig, 	/**/
                        int     input_max,
                        int     letter_max_line,
                        int     **compound_coordinates,
                        int     **connection,
                        int     unit_max,
                        struct substitute_struct *subs
                        /* char *CharField_substitute */ );

int read_box(						/**/	
			char 	***line_word_array,	/**/
			int 	i_line,			/**/
			int 	unit_read_flag,		/**/
             		int 	***input_box,		/**/
             		int 	***output_box,		/**/
             		int 	current_unit, 		/**/
                        int     input_max, 
                        struct substitute_struct *subs
                        /* char    *CharField_substitute */ );

int substitute_property_in_xfig_object(char ***line_word_array,int line,
                struct substitute_struct *subs,int prop_pos,
                int setvalue);



int get_upper_left(					/**/	
			char 	***line_word_array,	/**/
			int 	i_line,			/**/
		   	int 	co1,			/**/
		   	int 	co2,			/**/
		   	int 	co3,			/**/
		   	int 	co4,			/**/
		   	int 	co5);			/**/

int get_lower_right(					/**/
			char 	***line_word_array,	/**/
			int 	i_line,			/**/
		   	int 	co1,			/**/
		   	int 	co2,			/**/
		   	int 	co3,			/**/
		   	int 	co4,			/**/
		   	int 	co5);			/**/

int str2int(						/**/
			char 	***line_word_array,	/**/
			int 	i_line,			/**/
	    		int 	line_offset,		/**/
	    		int 	word,			/**/
			int 	letter_offset);		/**/

int check_input_box(					/**/
			char 	***line_word_array,	/**/
			int 	i_line,			/**/
		    	int 	x1,			/**/
		    	int 	y1,			/**/
		    	int 	x2,			/**/
		    	int 	y2, 			/**/
                        int *orientation);

int read_infos(						/**/
			char 	***line_word_array,	/**/
			int 	i_line,			/**/
			int 	current_unit,		/**/
               		double 	**par_xfig,		/**/
               		char 	***par_comment,		/**/
               		double 	**inp_init_xfig,	/**/
               		char 	***inp_unit_xfig,	/**/
                      	char 	***inp_comment,		/**/
               		double 	**deriv_xfig,		/**/
               		char 	***deriv_comment,	/**/
               		double 	**out_xfig,		/**/
               		char 	***out_unit_xfig,	/**/
                      	char 	***out_comment,		/**/
               		int 	*type_xfig,		/**/
               		int 	*unit_xfig,		/**/
               		char 	**info_line, 		/**/
                        int     letter_max_line );

int read_connections(					/**/
			char 	***line_word_array,	/**/
			int 	i_line,			/**/
			int 	current_unit,		/**/
                 	int 	***input_box,		/**/
                 	int 	***output_box,		/**/
                 	int 	un_max_xfig,		/**/
                 	int 	**input_unit_xfig,	/**/
                 	int 	**input_out_nr_xfig, 	/**/
                        int     input_max,
                        int     **connection,
                        struct substitute_struct *subs );

int inttostr(						/**/
			int 	no,			/**/
			char 	*int_string);		/**/

int write_dek(						/**/
			char 	***line_word_array,	/**/
			int 	unit_max_xfig,		/**/
              		double 	**par_xfig,		/**/
              		char 	***par_comment,		/**/
              		double 	**inp_init_xfig,	/**/
              		char 	***inp_unit_xfig,	/**/
                   	char 	***inp_comment,		/**/
             		double 	**deriv_xfig,		/**/
             		char 	***deriv_comment,	/**/
              		double 	**out_xfig,		/**/
              		char 	***out_unit_xfig,	/**/
                	char 	***out_comment,		/**/
              		int 	*type_xfig,		/**/
              		int 	*unit_xfig,		/**/
              		char 	**info_line,		/**/
              		int 	**input_unit_xfig,	/**/
              		int 	**input_out_nr_xfig, 	/**/
                        int     par_max,
                        int     deriv_max, 
                        int     input_max);

int editor(						/* editor */
			int 	*type,			/**/
			double 	**par,			/**/
			int 	**in_u,			/**/
			int 	**in_nr,		/**/
                	double 	**out_n,		/**/
                	double 	**deriv_o,		/**/
                	char 	***line_word_array,	/**/
                	int 	no_of_lines,		/**/
               		int 	***input_box,		/**/
               		int 	***output_box,		/**/
                	double 	**par_xfig,		/**/
                	char 	***par_comment,		/**/
                	double 	**inp_init_xfig,	/**/
                	char 	***inp_unit_xfig,	/**/
                     	char 	***inp_comment,		/**/
                	double 	**deriv_xfig,		/**/
                	char 	***deriv_comment,	/**/
                	double 	**out_xfig,		/**/
                	char 	***out_unit_xfig,	/**/
                       	char 	***out_comment,		/**/
                	int 	*type_xfig,		/**/
                	int 	*unit_xfig,		/**/
                	char 	**info_line,		/**/
                	int 	**input_unit_xfig,	/**/
                	int 	**input_out_nr_xfig) ;	/**/


/*----TRASH IN HISTORY----------------------------------------------------------------*/

/*int xfig_script_reader(int *type,double **par,int **in_u,int **in_nr,
                double **out_n,double **deriv_o,char ***line_word_array);*/
                
/*returns no_of lines of 'xfig_script' */

/* returns check */

