/*
   xfig-parser: fig2dek converts xfig3.1 ColSim files to simulationscript
   V0.1

   Christof Wittwer/ISE
   thanks to : ROM Umwelt-Stiftung & Fraunhofer-ISE,D-79100-Freiburg
                                    &  LBTA University Karlsruhe
   04/08/95
 
 * Copyright (C) 1995  Christof Wittwer
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
*/
/*
001113 malloc out_comment OUT_MAX instead of par_max
001114 out_comment==NULL defaults 
010713 uni_max added to interpreter()
*/

#include <time.h>  
#include <stdio.h>    
#include <stdlib.h>
#include <string.h> 
#include <math.h>    
#include <unistd.h>
#include <sys/stat.h>

#include "global.h"



int main()
{
int a=0; /*-----ANALYCE with a=1----------------------*/
int AutoRouter_flag=1;
int i_malloc=0;

int i,i1,i2; /*laufvariable*/
/* int un_max=0; / * max units in script != UNIT_MAX*/
int un_max_xfig=0;


int no_of_lines; /* in xfig_script */
int field_max_dyn;
char ***line_word_array; /* word of each line of 'sim.fig */

int *type;
int *type_xfig;
int *unit_xfig;
char **info_line;

double **parameter,**par_xfig; char ***par_comment;
int **input_unit;
int **input_out_nr;
int **input_unit_xfig;
int **input_out_nr_xfig;

double **inp_init_xfig; char ***inp_unit_xfig,***inp_comment;

int ***input_box; /*[unit][no][0..4] 0:line,1:x1,2:y1,3:x2,4:y2*/
int ***output_box;

double **out_present;
double **out_xfig;char ***out_unit_xfig,***out_comment;

double **deriv_o;  /*DERIVATIVES_OLD */
double **deriv_xfig; char ***deriv_comment;
char *CharField; /* Field for .fig file */
int **compound_coordinates; /* get xfig compound coord. for auto router */
int **connection; /* store coordinates of connection */

struct stat buf[2];
int unit_max,par_max,field_max,line_max,word_max,letter_max,deriv_max;
int input_max;
int letter_max_line=0;
int **x_connection; /* auto_router_coordinates of connections */
int **y_connection;
/* create array for substitutet line_word_array entries */
char CharField_substitute_array[SUBSTITUTE_MAX];
/* char *CharField_substitute=CharField_substitute_array; */
struct substitute_struct *subs,substitute_array; 

subs=&substitute_array;
subs->CharField=CharField_substitute_array;
subs->point=0;
subs->CharField[subs->point]='\0';

/*----START fig2dek -*/

/*----INSTALL ARRAYS----------------------------------------------------*/
/* get file informations with stat() to make dynamic allocation of arrays */
stat("sim.fig",buf);
field_max_dyn=(int) buf[0].st_size;
if (a) printf("'sim.fig' has total size of:%d \n", field_max_dyn); 

/* call read_fig() init, gets fieldsizes */
no_of_lines=read_fig(line_word_array,CharField,field_max_dyn,
          &unit_max,&par_max,&field_max,&line_max,&word_max,&letter_max
           ,&deriv_max,&input_max,&letter_max_line);
/*
*unit_max=unit_count;
 *par_max=par_count;
 *field_max=letter_count;
 *line_max=i_line;
 *word_max=word_count;
 *letter_max=letter_word;
 *deriv_max=deriv_count;
*/

if (a) printf("malloc  with: unit_max:%d par_max:%d field_max:%d \n"
       "line_max:%d word_max:%d letter_max:%d deriv_max:%d inp_max:%d\n"
       "letter_max_line:%d \n"
      ,unit_max,par_max,field_max,line_max,word_max,letter_max,deriv_max
      ,input_max,letter_max_line);

/* line_word_array=malloc_3char(line_max+2,word_max+2,3); */
line_word_array=(char***) malloc(sizeof(char**)*(line_max+5));
 if (line_word_array==0) { exit(-1); }
 for (i=0;i<=line_max+4;i++)
  {
  line_word_array[i]=(char**) malloc(sizeof(char*)*(word_max+3));
  if (line_word_array[i]==NULL) { printf("malloc_3char error\n"); }
  }
for (i=0;i<=line_max+4;i++)
 for (i1=0;i1<word_max+3;i1++) line_word_array[i][i1]=NULL;

if (a) printf("malloc:%d  line_word_array:[%d][%d][]\n"
   ,i_malloc++,line_max+2,word_max+2);

/* alloc CharField larger than nr_of_bytes, caused by extra words for tabs */
CharField=(char*) malloc(sizeof(char )* (field_max_dyn+line_max+LINE_MAX));
for (i1=0;i1< field_max_dyn+line_max;i1++) CharField[i1]='\0';
if (a) printf("malloc:%d  CharField[%d] ready\n"
 ,i_malloc++,field_max_dyn+line_max);

par_comment    =malloc_3char(unit_max+2,par_max+2,letter_max_line+2);
if (a) printf("malloc:%d par_comment[%d][%d][%d]\n",
 i_malloc,unit_max+2,par_max+2,letter_max_line+2);

inp_unit_xfig  =malloc_3char(unit_max+2,input_max+2,1); 
if (a) printf("malloc:%d  inp_unit_xfig:input_max:%d \n",i_malloc++,input_max); 
inp_comment    =malloc_3char(unit_max+2,input_max+2,letter_max_line+2);
if (a) printf("malloc:%d  ready\n",i_malloc++);
deriv_comment  =malloc_3char(unit_max+2,deriv_max+2,letter_max_line+2);
if (a) printf("malloc:%d  ready\n",i_malloc++);
out_unit_xfig  =malloc_3char(unit_max+2,par_max+2,letter_max+2);
if (a) printf("malloc:%d  ready\n",i_malloc++);
out_comment    =malloc_3char(unit_max+2,OUT_MAX+2,letter_max_line+2);
for (i=0;i<unit_max+2;i++)
 for (i1=0;i1<OUT_MAX+2;i1++) out_comment[i][i1]=NULL; /* initilize pointer*/

if (a) printf("malloc:%d  ready\n",i_malloc++);
info_line      =malloc_2char(unit_max+2,50);

if (a) printf("malloc:%d  ready\n",i_malloc++);

type=     malloc_1int(unit_max+1);
type_xfig=malloc_1int(unit_max+1);
unit_xfig=malloc_1int(unit_max+1);
if (a) printf("malloc:%d  ready\n",i_malloc++);

parameter=par_xfig=malloc_2double(unit_max+1,par_max+1);
if (a) printf("malloc:%d  ready\n",i_malloc++);

input_unit       =malloc_2int(unit_max+1,input_max+1);
input_out_nr     =malloc_2int(unit_max+1,input_max+1);
input_unit_xfig  =malloc_2int(unit_max+1,input_max+1);
input_out_nr_xfig=malloc_2int(unit_max+1,input_max+1);
input_box        =malloc_3int(unit_max+1,input_max+2,5);
output_box       =malloc_3int(unit_max+1,OUT_MAX+2,5);
if (a) printf("malloc:%d  ready input_max:%d\n",i_malloc++,input_max); 

inp_init_xfig=malloc_2double(unit_max+1,input_max+1);
if (a) printf("malloc:%d  ready\n",i_malloc++);

out_present=malloc_2double(unit_max+1,OUT_MAX+1);
out_xfig   =malloc_2double(unit_max+1,OUT_MAX+1);
deriv_o    =malloc_2double(unit_max+1,deriv_max+1);
deriv_xfig=malloc_2double(unit_max+1,deriv_max+1);

compound_coordinates=malloc_2int(unit_max+2,5); /* xfig coordinates */
connection          =malloc_2int(CONNECTION_MAX,7); /* 4coords,line,line-offs*/
connection[0][1]=END; /* init */
x_connection=malloc_2int(CONNECTION_MAX,EDGE_MAX);
y_connection=malloc_2int(CONNECTION_MAX,EDGE_MAX);


if (a) printf("malloc:%d  final ready\n",i_malloc++);

/*--------------DEFAULTS FOR ARRAYS------------------------------------*/

for (i=1;i<=unit_max;i++)
  {
  type[i]=0;
  for (i1=1;i1<=par_max;i1++)   { parameter      [i][i1]=0;
                                  par_xfig       [i][i1]=-99.99;}
  for (i1=1;i1<=OUT_MAX;i1++)     out_present    [i][i1]=0;
  for (i1=1;i1<=deriv_max;i1++) { deriv_o        [i][i1]=0;
                                  deriv_xfig     [i][i1]=-99.99; }
  for (i1=1;i1<=input_max;i1++)
    {
    input_unit          [i][i1]
      =input_unit_xfig  [i][i1]
      =input_out_nr_xfig[i][i1]
      =input_out_nr     [i][i1]=0;
    inp_init_xfig[i][i1]=-99.99;
    for (i2=0;i2<=4;i2++) input_box   [i][i1][i2]
                           =output_box[i][i1][i2]=0;
    }
   input_box[i]  [input_max+1][1]=output_box[i][OUT_MAX+1][1]=END;
   input_box[i+1][1][1]=output_box[i+1][1][1]=END;
  };
if (a) printf("input_unit_xfig:[%d][%d]\n",i,i1); 
if (a) printf(" init parameter,par_xfig,out_present,deriv_o,deriv_xfig ready\n"); 

/*------------READ DEK-FILE--------------------------------------------*/
/*
un_max=read_dek(type,parameter,input_unit,input_out_nr,
                  out_present,deriv_o);
if (un_max>= unit_max)
  {
    printf("exit, to much units in dek \n");
    exit (-1);
  }
printf("DekRead: %d units detected in 'sim.dek' \n",un_max);
*/

#if 0
/*---------UNIT-ORDER FOR SIMULATION----------------------------------*/

i_unit=0; /*reset pointer of unit_order[] */
for (i=1;i<=un_max;i++)
 if (type[i]==62) unit_order[i_unit]=i;  /*SEARCH SIM-CONTROL */

for (i=1;i<=un_max;i++)
 if (type[i]==65) unit_order[i_unit]=i;  /*SEARCH GNU-PLOTTER */

for (i=1;i<=un_max;i++)
 if (   (type[i]!=62)
     && (type[i]!=65) )
                  unit_order[i_unit]=i;  /*SEARCH others */
#endif

/*---------XFIG-SCRIPT-READER-----------------------------------------*/

if (a) printf("now read_xfig_script\n");

if (1)
no_of_lines=read_fig(line_word_array,CharField,field_max_dyn,
          &unit_max,&par_max,&field_max,&line_max,&word_max,&letter_max
          ,&deriv_max,&input_max,&letter_max_line);

if (a) printf("no_of_lines of xfig-script:%d invoking interpreter\n"
              ,no_of_lines);

un_max_xfig=
 interpreter(type,parameter,input_unit,input_out_nr,
            out_present,deriv_o,line_word_array,no_of_lines
            ,input_box,output_box,par_xfig,par_comment,inp_init_xfig,
            inp_unit_xfig,inp_comment,deriv_xfig,deriv_comment,
            out_xfig,out_unit_xfig,out_comment,
            type_xfig,unit_xfig,info_line,
            input_unit_xfig,input_out_nr_xfig,input_max,
            letter_max_line,compound_coordinates,connection,
            unit_max,subs /*CharField_substitute*/ );
if (a) printf("...interpreter() done\n");

if (AutoRouter_flag) auto_router(line_word_array,no_of_lines,
            input_box,output_box,
            letter_max_line,compound_coordinates,connection,
            x_connection,y_connection);


/*----EDITOR---------------------------------------------------------*/

if (0) editor(type,parameter,input_unit,input_out_nr,
            out_present,deriv_o,line_word_array,no_of_lines
            ,input_box,output_box,par_xfig,par_comment,inp_init_xfig,
            inp_unit_xfig,inp_comment,deriv_xfig,deriv_comment,
            out_xfig,out_unit_xfig,out_comment,
            type_xfig,unit_xfig,info_line,
            input_unit_xfig,input_out_nr_xfig);
/* returns check */

/*----WRITE XFIG-SCRIPT---------------------------------------------*/
if (a) printf("invoking write_fig\n");
if (AutoRouter_flag) write_fig(line_word_array,no_of_lines,compound_coordinates,
          connection,x_connection,y_connection,AutoRouter_flag); /* 'sim_new.fig'*/
if (a) printf("..write_fig ready\n");


/*change_form()*/

/*----WRITE DEK------------------------------------------------------*/
if (a) printf("invoking write_dek \n");
write_dek(line_word_array,un_max_xfig,par_xfig,par_comment,
          inp_init_xfig,inp_unit_xfig,inp_comment,
          deriv_xfig,deriv_comment,
          out_xfig,out_unit_xfig,out_comment,
          type_xfig,unit_xfig,info_line,
          input_unit_xfig,input_out_nr_xfig,par_max
          ,deriv_max,input_max);
printf("sim_new.dek written\n");

return 0;
}

