# sum of energy in the year with sim_out.dat
# call: Auswertung.awk <../sim_out1.dat 
awk '
  BEGIN {
	  print"Auswertung Heizungssystem (macro/Auswertung.awk) "
	  print"PARAMETER2: Low Flow System "
	  n=0
        }
  {
  n+=1
  co[0]=$1
  if (n==1) nf=NF
  for(i=1;i<=NF;i+=1) co[i]=co[i]+$(i+1)
  }
END {
    EtaColl=100*co[2]/co[1]
    EtaCollWT=100*co[3]/co[2]
    LossSolPipe=co[2]-co[3]
    EtaLoadBW=100*co[5]/co[4]
    LossHeating=-co[8]+co[9]+co[10]
    Deckung1=100*co[3]/co[6]
    DeckungLast=100*co[3]/(-co[9]-co[10]+co[5])
    DeckungHeater=100*co[6]/(-co[9]-co[10]+co[5])
    SystemLosses=LossSolPipe+LossHeating+co[7]+co[4]-co[5]
    Heizenenergie140m2=(-co[9]-co[10])/140
    
    print"  \n"
    printf("EtaColl             %.3f %\n",EtaColl);
    printf("EtaCollWT           %.3f %\n",EtaCollWT);
    printf("LossSolPipe         %.3f [kWh]\n",LossSolPipe);
    printf("EtaLoadBW           %.3f %\n",EtaLoadBW);
    printf("LossHeating         %.3f [kWh]\n",LossHeating);
    printf("Deckung1            %.3f %\n",Deckung1);
    printf("DeckungLast         %.3f %\n",DeckungLast);
    printf("DeckungHeater       %.3f %\n",DeckungHeater);
    printf("SystemLosses        %.3f [kWh]\n",SystemLosses);
    printf("Heizenenergie140m2  %.3f [kWh]\n",Heizenenergie140m2);
    print"  \n"
    printf("Q_sun:       %.3f [kWh]\n",co[1]);
    printf("Q_coll:      %.3f [kWh]\n",co[2]);
    printf("Q_wt_sol:    %.3f [kWh]\n",co[3]);
    printf("Qext_wt:     %.3f [kWh]\n",co[4]);
    printf("Q_load:      %.3f [kWh]\n",co[5]);
    printf("Q_heater:    %.3f [kWh]\n",co[6]);
    printf("QlossUNI:    %.3f [kWh]\n",co[7]);
    printf("Q_heating:   %.3f [kWh]\n",co[8]);
    printf("Qheating1:   %.3f [kWh]\n",co[9]);
    printf("Qheating2:   %.3f [kWh]\n",co[10]);
    printf("Q_passiv1:   %.3f [kWh]\n",co[11]);
    printf("Q_pump_sol1: %.3f [kWh]\n",co[12]);
    printf("Q_loss1:     %.3f [kWh]\n",co[13]);
    printf("Q_loss2:     %.3f [kWh]\n",co[14]);

    
    #for(i=1;i<=(nf-1);i+=1) printf("%2d.) %.3f mean_(/%d): %.3f \n" \
    #                       ,i,co[i],(n-1),co[i]/(n-1));
    printf("\n");
    }
'
