# gnuplot <energiebilanz.boxes.gnu >energiebilanz.boxes.fig
set term fig color big metric thickness 1 depth 50 fontsize 12
#set term postscript color solid
# #TIME TIME_OF_DAY Q_loss_Sp1 Q_WP_abluft Q_FW Q_Koll2 Q_WP 
#
set title "EnergyBalance SolarHouse Gundelfingen (Fraunhofer-ISE,FBTA Uni-Karlsruhe)"
set xrange [0:365]
set key below
set grid
set xlabel "day of year [d]"
set ylabel "energy demand per day [kWh]"
set xtics 30 
set data style boxxy
#
# get Q_WP_abluft and Q_FW through balance
# daily_q_fw.dat: #TIME TIME_OF_DAY Q_loss_Sp1 Q_WP_abluft Q_FW Q_Koll2 Q_WP Q_FW_new
#
!awk -f Q_FW.awk daily.dat >daily_q_fw.dat
!awk -f boxes.awk -v x=2 -v dx=1 -v dy1=32 -v dy2=33 -v dy3=34 -v offs=0    -v f=1  daily.dat >boxes1.gnu.dat
!awk -f boxes.awk -v x=2 -v dx=1 -v dy1=8  -v dy2=6  -v dy3=7  -v offs=0    -v f=-1 daily_q_fw.dat >boxes2.gnu.dat
!awk -f boxes.awk -v x=2 -v dx=1 -v dy1=30                     -v offs=400 -v f=-10 daily.dat >boxes3.gnu.dat
#
plot "boxes1.gnu.dat" us 1:2:3:4 ti "Q_Htg","" us 5:6:7:8 ti "Q_WW" wi boxxy,"" us 9:10:11:12 ti "Q_Zirk" \
,"boxes2.gnu.dat" us 1:2:3:4 ti "Q_FW_new","" us 5:6:7:8 ti "Q_SOL","" us 9:10:11:12 ti "Q_WP" \
,"boxes3.gnu.dat" us 1:2:3:4 ti "Q_Sun_hor*10"
#
#plot "boxes.dat" us 1:($2+$4*0.5):($3*0.5):($4*0.5) t "Power" with boxxy,\
#"" us 5:($4+$8*0.5):($7*0.5):($8*0.5) t "Power" with boxxy 

# !awk -f boxes.awk -v x=1 -v dx=1 -v dy1=2 -v dy2=3 -v dy3=4 -v dy4=5 boxes.dat >boxes.gnu.dat
# plot "boxes.gnu.dat" us 1:2:3:4 ti "Q_Htg","" us 5:6:7:8 ti "Q_WW" wi boxxy,"" us 9:10:11:12 ti "Q_Zirk" 


