# awk -f etc/histogramm.awk <sim_out8.dat >histogramm.dat
#


BEGIN {
   # Eckwerte Haeufigkeitsverteilung
   anzahl_der_klassen = 150   #  !!!!!! EDIT !!!!!!!!!!!!!!
   klassenweite = 0.25        # !!!!!!!! EDIT !!!!!!!!!!!
   # Faktor zur Normierung (mind. > 0, ohne = 1)
   norm = 1

   # (a)bsolut oder (r)elativ
   art = "r"
   # NULL-Klasse (e)xtra oder (n)icht
   nkl = "n"
   # Betrachtete Stunden incl. (-1 fuer alle)
   vonstunde = -1
   bisstunde = -1

   # Start
   # getline;
   FS= " "
   min=9999
}

# MAIN (bezieht sich immer auf eine Zeile)
{
   # Wo ist was
   zeit  = $1/3600   # !!!!!!!!!!!!!! EDIT !!!!!!!!
   spalte= $12  # !!!!!!!!!!!!!! EDIT !!!!!!!!!!!!!!!!!!!

   # Stundenabfrage
   stunden = int(zeit)           #substr(zeit,1,2)
   minuten = 60*(zeit-int(zeit)) #substr(zeit,3,2)
   if (minuten>30) {stunden+1}
   if ((vonstunde<=stunden) && (bisstunde>=stunden) || (vonstunde<0)) {
      
      # Klassenzaehlung
      klasse = int(spalte/klassenweite)*klassenweite+(klassenweite/2)
      # Sonderbehandlung fuer Werte kleiner 0.0001 
      if ((nkl == "e") && (spalte<0.0001)) {klasse = 0.0}
      h[klasse]++
      if (min>spalte) {min=spalte}
      if (max<spalte) {max=spalte}
      sum += spalte/norm
      sumq+= spalte*spalte/norm/norm
      anz++
      }
}

END {
   # Varianz
   var= ((anz*sumq)-(sum*sum))/(anz*anz)
   # Ergebnisse in Histo-Datei schreiben (keine Prozente)
 #  printf("%s,Nr=%d\n", einname, anz);

      # Bercksichtigte Stunden
      if (vonstunde<0) {vonstunde=0; bisstunde=24}
 #     printf("Std.=%.d-%.d,Hfgk.\n",vonstunde,bisstunde);

      # Sonderbehandlung fr NULL-Klasse
      if (nkl == "e") {printf("0.0000,%.4f\n",h[klasse]/anz)}

      # Klassen schreiben
      for (i=0; i<anzahl_der_klassen; i++) {
         klasse = (i*klassenweite)+(klassenweite/2)
         if (art == "a") {anz=1}
         integral+=h[klasse]/anz
         printf("%.4f %.4f %.4f \n", klasse/norm, h[klasse]/anz,integral)
         }

   # Statistische Erbebnisse in 2. Datei schreiben (keine Prozente)
   # printf("Datei,Anz,M,M*M,M^2,Var,Stabw,Min,Max\n"); 
#   printf("%s,%d,%.4f,%.4f,%.4f,", einname, anz, sum/anz, sum/anz*sum/anz, sumq/anz) ;
#   printf("%.4f,%.4f,%.4f,%.4f\n",var,sqrt(var),min/norm,max/norm) ;
   

}
