#include <stdio.h>
#include <stdlib.h>   
#include <math.h>

/* Programm berechnet ColSim-Verschattungsfile fuer ein Fenster mit starrem
   rechteckigem berbau. Einzugeben: Breite und Tiefe der Verschattung, sowie
   Hoehe ueber einem Bezugspunkt etwa in der Fenstermitte. 
   Ausgabe: File "horizon.inp".
*/ 
  


int main(void)
{
  double hoehe,breite,tiefe,alpha;
  double rad;
  FILE *horizon_file;

  rad= 3.14159/180.0;
  printf("Hhe der Verschattung ber dem Bezugspunkt in Metern:\n");
  scanf("%lf",&hoehe);
  printf("Breite der Verschattung in Metern:\n");
  scanf("%lf",&breite);
  printf("Tiefe der Verschattung in Metern:\n");
  scanf("%lf",&tiefe);

  horizon_file=fopen("horizon.inp","w");
  fprintf(horizon_file,"horizon for rad_processor in ColSim :\n");
  fprintf(horizon_file,
  "1.azi (-180..180) 2. zenit_overhang (0..180) 3. zenit_horizon\n");
  fprintf(horizon_file,
   "\n-180 -90  -80  -70  -60   -50  -40  -30  -20   -10   0  "
          " 10   20   30   40   50   60   70   80    90  180 \n");
  fprintf(horizon_file,"\n");
  fprintf(horizon_file,"   0 ");
 
  for (alpha=-90;alpha<=90;alpha+=10)
  {
      double alpha_eck,teta;
      
      alpha_eck= atan( breite/(2.0*tiefe) )/rad;
      if (fabs(alpha) < alpha_eck)
	  teta=atan(hoehe/tiefe * cos(alpha*rad))/rad;
      else
          teta=fabs(atan(2.0*hoehe/breite * sin(alpha*rad))/rad);

      printf("alpha:%.2f,alpha_eck:%.2f,teta:%.2f\n",alpha,alpha_eck,teta);
      fprintf(horizon_file,"%.1f ",teta);
  }
  fprintf(horizon_file,"   0  \n");

  fprintf(horizon_file,"   0    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0\n");

  fclose(horizon_file);

  return 0;
}


  


