/*  SetUpHydraulicEquations.h 20000102  */
/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------------------------------------------*/

  struct t_hyd {
            int node_equ[30][4]; 
            int from[300]; /*path from node*/
            int to[300];   /*path to node*/
            int path_unit[30][30]; /*which unit in which path*/
            int path_type[30][30];
            double cetaA2[30];  
            double linear[30];
            double dp[30];
            double vdot[30];           
  
            int pump_path[10];  /*path of pump*/
            int pump_unit[10]; /*unit of pump*/
            double pump_P[10]; /*power of pump*/
            int pump_Pflag[10];   /*=1 if there is data for power of pump*/
            int pump_stages[10]; /*how many stages of pump*/     

            int pump_pr_node[10]; /* node before pump*/
            int nr_pumps; 
            int path_nr_unit[30]; /*units in path*/

            int nodes;
            int pathes;
            int nr_equ;
            int nr_var;

            int node_unit[30];
            int node_mix_div[30]; /*node_mix_div[node]=1 ->Mix ::=2 ->Div*/            
            int file_unit[30][30]; /*in path which unit of fileCoeff*/
            int file_unit_called[30][30]; /*in path nth of unit */
            int file_node_unit[30][30]; 
            int file_node_unit_called[30][30];/*wird das noch gebraucht ?*/
            char filename_node[30][40];
            char filename_path[30][3][40];

            int mixdiv[70]; /*mixdiv[node]=1 Mix =2 Div*/
            int mixdivall[70]; /* */
            double roh;            
            };

  double get_dvalue ();
  double get_value ();
  int init_getvalue();
  double getdoublefromstring ();
  int hydraulic_info ();
  float signd ();
  int signi ();
  void lubksb ();
  int usrfun ();
  int dmnewt ();
#define TYPE_MAX 200  /* later to define in global.h */
#define HYD_PATH_MAX 300  /* path number between nodes (mixer and diverters */
#define PATH_UNIT_MAX 80  /* number of units per path */
#define HYD_NODE_MAX 70   /* mixers + diverters */
#define CYCLE_MAX    50   /* mixers + diverters */

#define PUMP      3 /* hydraulic type number from unit_order.h*/
#define DIVERTER 11 
#define MIXER    13 
#define PIPE     31
#define VALVE    36
#define HYDRESIST 38
#define DIVERTER_AIR 47
#define PIPE_AIR 32
#define PUMP_AIR 49
#define MIXER_AIR 48
 /* following tyeps are used for PathUnitType  [CurrentPath][PathUnitNumber] */

#define DivIn   1  /* Types of In and Output in Mixer and Diverter */
#define DivOut0 2  /* used to catch ceta's for each path */
#define DivOut1 3

#define MixIn1  4
#define MixIn2  5
#define MixOut  6

#define PumpIn  7
#define PumpOut 8

#define PipeCeta 9  /*?*/
#define ValveCeta 10
#define TypeHydResist  11 


/* Hydraulic Ports of the types */
#define PumpParA   8
#define PumpParB   9
#define PumpParC   10
#define PumpInCtr  3
#define PumpOut_dP 15

#define PipeParCeta 7
#define PipeParLin  8
#define PipeParOut_dP 14

#define DivParCetaIn 2
#define DivInCtr     3
#define DivOutCeta0  9
#define DivOutCeta1  10
#define DivOut_dP    11

#define MixParCeta0  2
#define MixParCeta1  3
#define MixOutCeta   9
#define MixOut_dP0   10
#define MixOut_dP1   11

#define ValveCetaA2  3
#define ValveLinearCoeff 4
#define ValvedeltaP_Coeff 5
/* Airdraulic*/
#define PipeAirParCeta 9

#define DivParAirCetaIn 2
#define DivInAirCtr     3
#define DivOutAirCeta0  21
#define DivOutAirCeta1  22

#define MixAirParCeta0  2
#define MixAirParCeta1  3
#define MixAirOutCeta   4



int SetUpHydraulicEquations();

int SetSumOfCeta();                           
int usrfun();
int hydraulic_init();
void matrausg();
int hydraulic_info();
int hydraulic_info_erg();
int dmnewt();
/* numerical recipes */

#define TINY 1.0e-20;


void ludcmp( double **a,int n,int *indx, double *d );

void lubksb( double **a, int n, int *indx,double b[] );

void nrerror( char error_text[]) ;

float *vector( int nl,int nh) ;

double *dvector();
void dlubksb();
void dludcmp();
