/* equation.c */
/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------------------------------------------*/


/*#include "global.h"*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define IN_MAX 10

/*--------------------------------------EQUATION--------TYPE 24 --------------*/
int equation(unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
             qp_sum,tsim,init_flag,day_of_year)
           int    unit;      /* current unit number */
           double **par;     /* parameter array par[unit][1..PARMAX]  */
           int    **in_u;    /* input unit array, input connections   */
           int    **in_nr;   /* input number array                    */
           double **out_o;   /* output array with privious state      */
           double **out_n;   /* output array with current state       */
           double **deriv_o; /* derivatives: used for diffential equ. */
           double **deriv_n; /*  new state of deriv                   */
           double h;         /* sim time step                         */
           double **init_energy; /* initial energy in RC-comp. [Ws]   */
           double ***qp_sum; /* energy to one node qp[unit][n][m]     */
           double tsim;      /* simulation time in [s] of this day    */
           int    init_flag; /* set at initial loop of sim            */
           int    day_of_year;
{
/*  
    TYPE 24
    PRIORITY  2          used by config routine
    HYDRAULIC 99         used by config routine
  
    PAR1: 1 [] equation-set 0...99
    PAR2: 1 [] dummy 1

    INP1: 0 [] inp1
    INP2: 0 [] inp2 
    INP3: 0 [] inp3
    INP4: 0 [] inp4
    INP5: 0 [] inp5
    INP6: 0 [] inp6
    INP7: 0 [] inp7
    INP8: 0 [] inp8 
    INP9: 0 [] inp9
    INP10: 0 [] inp10
    INP11: 0 [] inp11
    INP12: 0 [] inp12
    INP13: 0 [] inp13
    INP14: 0 [] inp14
    INP15: 0 [] inp15
  
    OUT1: [] equation1
    OUT2: [] equation2
    OUT3: [] equation3
    OUT4: [] equation4
    OUT6: [Ws] system inlet energy 
    OUT7: [Ws] system outlet energy 
    OUT8: [Ws] internal energy 
    OUT9: []  equation5
    
*/
  static double input[IN_MAX+1];
  int i;
  
  if (init_flag)
      for (i=1;i<=IN_MAX;i++) out_n[unit][i]=out_o[unit][i]=0;

  for (i=1;i<=IN_MAX;i++) input[i]=out_n[  in_u[unit][i] ]
                                        [ in_nr[unit][i] ];
					
  
  switch ( (int) par[unit][1] ) /* equation-set 0...99*/
   {
   case 1: /* operation time */
      {
      /* double cp=par[unit][1];  */
      double stagnation_state=input[2];
      printf("equation[%d] uncomplete\n",unit); exit (-1);
     
      if (stagnation_state>0) out_o[unit][3]=out_n[unit][3]+=(h/3600);
      
      break;
      }
   case 2:
      {
      printf("equation[%d] uncomplete\n",unit); exit (-1);
      break;
      }
   default: 
      printf("equation-set unit:%d not valid\n",unit);
      exit (-1);
   }
  
  return 1;
}


