/* fluid_properties.c 
fluid properties
 */

/*
010627 fluid_properties.c created 
*/

#include "global.h" /* METHOD_WATER,METHOD_GLYCOL */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>



#define PEDANTIC_FLUID_PROPERTIES 1

/* ---------------------------------------------------------------------------*/
double Get_cp_from_Temp(int unit,int method,double T)
{
double cp=4.19;
return (cp);
}; /* Get_cp_from_Temp */

/* ---------------------------------------------------------------------------*/
double Get_rho_from_Temp(int unit,int method,double T)
{
double rho;

switch (method) {
 case METHOD_WATER:
 {
 double rho_A0=999.85,rho_A1=6.187e-2,rho_A2=-7.654e-3,rho_A3=3.974e-5,
        rho_A4=-1.110e-7;
 double T2=T*T;
 double T4=T2*T2;
 rho= rho_A0+rho_A1*T+rho_A2*T2+rho_A3*T*T2+rho_A4*T4;
 break;
 }
 default: printf("Get_rho_from_Temp: unit:%d unknown method:%d\n",
                 unit,method); exit (-1);
} /* switch */
return (rho);
}; /* Get_rho_from_Temp */

