/* thermodynamics.h ColSim */

/*
010627 thermodynamics.h created
       global.orig.h definitions for thermodynamics moved to here
*/

#define CP_AIR_DRY 1007    /* [J/kgK] spec. heat capacity dry air (p=ct) */
#define CP_STEAM   1860    /* [J/kgK] spec. heat capacity steam (water)*/
#define CP_WATER   4190    /* [J/kgK] spec. heat capacity water */
#define EVAP_ENTH  2501000 /* [J/kgK] Evaporation enthalpy water */

#define P_ATM 1000         /* [hPa]  hPa=100 Pa = mbar */


/* ---------------------------------------------------------------------------*/
int GetMixedOutPlug(double *dQ_out,double *mp_steam_out,
                    double *T_node_new, double H_node,
                    double *m_dry_node,double *m_steam_node,
                    double *m_water_node,
                    double mp_water_gain_node,double mp_steam_gain_node,
                    double mp_dry_in,double mp_steam_in,
                    double h,double Pgain,double *dQgain,
                    int NoCondens, int use_adsorption,
                    double m_steam_adsorp_max,double *m_steam_adsorp,
                    double k_adsorp,double *x_s);
/* ---------------------------------------------------------------------------*/

/*------------------- defs for thermodynamics --------------------------------*/
double Get_enthalpy_from_temp(double T,double m_air,double m_steam,
                              double m_water);

double Get_phi_from_xs(double x,double x_s);
double Get_xs_from_enthalpy(double H,double m_air,double m_water,double T);
double Get_xs_from_enthalpy2(double h); /* christiane */

double Get_Temp_from_enthalpy(double H,double m_air,double m_steam
                             ,double m_water);
double Get_p_steam_s (double T_air);       /* [N/m2] pressure saturated air*/
double Get_phi(double T_air,double x);

double Get_x (double p_steam, double p_air);
double Get_rho_air_dry (double T_air, double p_air);
double Get_rho_humid (double T_air, double x, double p_air);
double Get_rho_co2(double T_air);
double Get_h_air_dry (double T_air);         /*[Ws/kg] enthalpie dry air*/
double Get_h_steam (double T_air);        /*[Ws/kg] enthalpie water steam*/
double Get_h_water (double T_air);         /*[Ws/kg] enthalpie water*/


double Get_alpha_air (double T_air, double di, double l_p, double m_in,
                    double t_step, double rho);
double Get_alpha_water (double T_water, double di, double l_p, double m_in,
                      double t_step);       /*[W/m2K] heat transfer water-pipe*/
double Get_f_mass (double a, double lambda, double alpha, double di, double da);

double Get_alpha_air (double T_air, double di, double l_p, double m_in,
                    double t_step, double rho);
                                           /*[W/m2K] heat transfer air-pipe*/
double Get_alpha_water (double T_water, double di, double l_p, double m_in,
                      double t_step);     /*[W/m2K] heat transfer water-pipe*/
double Get_f_mass (double a, double lambda, double alpha, double di, double da);
double Get_H_total (double T,double m_dry,double m_steam,double m_water)  ;
double Get_h_total (double T,double m_dry,double m_steam)  ;
/* ---------------------------------------------------------------------------*/

